import torch
import time
from torch.nn import functional as F
import numpy as np
from args import args
from compNB import return_opera
import networkx as nx
import random
def convert(filename,x):
    with open(filename,'r') as f:
         l=f.readlines()
    f.close
    n=ord(l[0][0])-63 #number of vertexs
    m=int(n*3/2) 
    p=int(n*(n-1)/2)
    last=p%6
    uptri_edges=[]
    for i in range(1,n,1):
       for j in range(0,i):
          uptri_edges.append([j,i])
    edges_index=[]
    line=l[x].strip()
    bitstring=''
    for j in range(1,len(line)):
       bitstring+=f'{ord(line[j])-63:6b}'
       #print(f'{ord(line[j])-63:6b}')
    for i in range(len(bitstring)):
        if bitstring[i]=='1':
           edges_index.append(i)
    return n,np.array(uptri_edges)[edges_index]  

def con_to_spars(B,E1,E2):
    return torch.sparse.FloatTensor(B.t(), torch.ones(B.shape[0]), torch.Size([E1.shape[0],E2.shape[0]]))
def con_to_spars1(B,n,E2):
    return torch.sparse.FloatTensor(B.t(), torch.ones(B.shape[0]), torch.Size([n,E2.shape[0]]))
def init_mf(n,bond):
    torch.manual_seed(args.seed1)
    marg_i=F.softmax(torch.rand(n, bond), dim=1)
    return marg_i
def init_bp(n,E1,bond):
    torch.manual_seed(args.seed1)
    marg_i = F.softmax(torch.rand(n, bond), dim=1)
    cav_ij = F.softmax(torch.rand(E1.shape[0], bond), dim=1)
    return marg_i,cav_ij
class MeanField():
    def __init__(self, graph,W,beta,mydevice):
        self.W=W@W.t()
        
        self.conv_crit = 1e-6
        self.max_iter = 2*10**3
        self.beta=beta
        self.graph=graph
        self.n=graph.number_of_nodes()
        self.device = mydevice
    def BP(self):
        E1 = np.array(list(self.graph.edges()))
        E1_ = np.ones(E1.shape,dtype=int)
        E1_[:,0:1]=E1[:,1:2]
        E1_[:,1:2]=E1[:,0:1]
        E1 = np.vstack((E1,E1_))
        B1,B1_ = return_opera(E1,self.n)
        spB1 = con_to_spars(B1,E1,E1)
        spB1_= con_to_spars1(B1_,n,E1)
        print(self.W.shape[0])
        marg_i,cav_ij=init_bp(self.n,E1,self.W.shape[0])
        marg_i=marg_i.to(self.device)
        cav_ij=cav_ij.to(self.device)
        spB1=spB1.to(self.device)
        spB1_=spB1_.to(self.device)
        iter_start_time=time.time()
        for step in range(self.max_iter):
           tmp=cav_ij
           #print(tmp)
           cav_ij = F.softmax(torch.spmm(spB1,torch.log(cav_ij @ self.W)),dim=1)
           #print(cav_ij)
           differ=torch.max(torch.abs(cav_ij-tmp))
           #print(differ)
           if differ<self.conv_crit:
              break;
           marg_i = F.softmax(torch.spmm(spB1_,torch.log(cav_ij @ self.W)),dim=1)
        print(step)
        print(differ)
        print(marg_i)
        # calculate free energy
        F_i=torch.log(torch.sum(torch.exp(torch.spmm(spB1_,torch.log(cav_ij @ self.W))),dim=1)).sum()
        F_ij=0
        m=self.graph.number_of_edges()
        for i in range(m):
          
            F_ij+=torch.log(cav_ij[i,:] @ self.W @ cav_ij[i+m,:].view(args.bond,1))
        Fe=F_i-F_ij
        return Fe
    def NMF(self):
        E1=np.array(list(self.graph.edges()))
        E1_ = np.ones(E1.shape,dtype=int)
        E1_[:,0:1]=E1[:,1:2]
        E1_[:,1:2]=E1[:,0:1]
        E1 = np.vstack((E1,E1_))
        A=torch.sparse.FloatTensor(torch.LongTensor(E1).t(), torch.ones(E1.shape[0]), torch.Size([self.n,self.n]))
        marg_i=init_mf(self.n,self.W.shape[0])
        marg_i=marg_i.to(self.device)
        A=A.to(self.device)
        for step in range(self.max_iter):
           tmp=marg_i
           #print(tmp)
           marg_i = F.softmax(torch.spmm(A,marg_i @ torch.log(self.W)),dim=1)
           differ=torch.max(torch.abs(marg_i-tmp))
           #print(differ)
           if differ<self.conv_crit:
              break;
        #calculate free energy
        U=0
        for u,v in list(self.graph.edges()):
           U-=marg_i[u] @ torch.log(self.W) @ marg_i[v].view(args.bond,1)
        S=0
        for i in range(self.n):
           S-=marg_i[i] @ torch.log(marg_i[i]).t()
        Fe=U-S
        return Fe        
        
if __name__ =='__main__'  :
    torch.set_default_dtype(torch.float64)
    n=20
    beta=1
    #graph = nx.random_regular_graph(3, n, seed=1)
    n,edges=convert('Generated_graphs.20.03.g6',args.which)
    
    if args.permutation:
       randomindex=[i for i in range(n)]
       random.shuffle(randomindex)
       randomindex=np.array(randomindex)
       edges[:,0]=randomindex[edges[:,0]]
       edges[:,1]=randomindex[edges[:,1]]
    G=nx.Graph()
    G.add_nodes_from(np.arange(n))
    G.add_edges_from(edges)
    n2,edges2=convert('Generated_graphs.20.03.g6',args.which+1)
    G1=nx.Graph()
    G1.add_nodes_from(np.arange(n2))
    G1.add_edges_from(edges2)
    torch.manual_seed(args.seed1)
    tensor2=torch.randn(args.bond,args.bond,dtype=torch.float64,device='cpu')
    #tensor2=torch.triu(tensor2)+torch.triu(tensor2,diagonal=1).t()
    mf=MeanField(G,torch.exp(beta*tensor2),beta,'cpu')
    fe_bp=mf.BP()
    print("free_energy={:.15g}".format(fe_bp.item()))
    fe_nmf=mf.NMF()/n
    print("free_energy={:.15g}".format(fe_nmf.item()))
       	
        